diff -r ee55d0546576 src/infrastructure.cpp
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/infrastructure.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -0,0 +1,415 @@
+/** @file infrastructure.cpp Implementation of infrastructure sharing */
+
+#include "infrastructure.h"
+#include "settings_type.h"
+#include "company_base.h"
+#include "command_func.h"
+#include "company_func.h"
+#include "window_func.h"
+#include "infrastructure_func.h"
+#include "depot_base.h"
+#include "train.h"
+#include "tunnelbridge_map.h"
+#include "pbs.h"
+#include "vehicle_func.h"
+#include "news_func.h"
+#include "strings_func.h"
+#include "core/mem_func.hpp"
+
+#include "table/strings.h"
+
+bool CompanySharingSettingsEntry::Equals(CompanySharingSettingsEntry *o)
+{
+	/* Since memcmp/MemCmpT is not guaranteed to work properly for structs, we do it this way */
+	return MemCmpT(this->option, o->option, SHARING_VEHTYPES) == 0
+		&& MemCmpT(this->fee, o->fee, SHARING_VEHTYPES) == 0
+		&& this->allowed_companies == o->allowed_companies;
+}
+
+byte CompanySharingSettingsEntry::Copy(CompanySharingSettingsEntry *o)
+{
+	byte changed_vehtypes = 0;
+	for (VehicleType vt = VEH_TRAIN; vt < SHARING_VEHTYPES; vt++) {
+		if (this->GetSharingOption(vt) != o->GetSharingOption(vt)) {
+			SetBit(changed_vehtypes, vt);
+		}
+	}
+	if ((this->allowed_companies & o->allowed_companies) != this->allowed_companies) changed_vehtypes = 0xF;
+
+	MemCpyT(this, o);
+
+	return changed_vehtypes;
+}
+
+byte CompanySharingSettingsEntry::CopyFromGameSettings()
+{
+	byte old_options[SHARING_VEHTYPES] = {0};
+	MemCpyT(old_options, this->option, SHARING_VEHTYPES);
+
+	if (_settings_game.sharing.enable_sharing) {
+		this->SetSharingOption(VEH_TRAIN,    _settings_game.sharing.rail_sharing > 0 ? _settings_game.sharing.rail_sharing + 3 : 0);
+		this->SetSharingOption(VEH_ROAD,     _settings_game.sharing.road_sharing ? SHARING_DEPOT | SHARING_STATION : 0);
+		this->SetSharingOption(VEH_SHIP,     _settings_game.sharing.water_sharing ? SHARING_DEPOT | SHARING_STATION : 0);
+		this->SetSharingOption(VEH_AIRCRAFT, _settings_game.sharing.air_sharing ? SHARING_DEPOT | SHARING_STATION : 0);
+	} else {
+		MemSetT(this->option, 0, SHARING_VEHTYPES);
+	}
+
+	/* Check which vehicle types have changed */
+	byte changed_vehtypes = 0;
+	for (VehicleType vt = VEH_TRAIN; vt < SHARING_VEHTYPES; vt++) {
+		if (old_options[vt] != this->GetSharingOption(vt)) SetBit(changed_vehtypes, vt);
+	}
+
+	/* Set the sharing fees to match the advanced settings */
+	this->SetSharingFee(VEH_TRAIN,    _settings_game.sharing.rail_fee);
+	this->SetSharingFee(VEH_ROAD,     _settings_game.sharing.road_fee);
+	this->SetSharingFee(VEH_SHIP,     _settings_game.sharing.water_fee);
+	this->SetSharingFee(VEH_AIRCRAFT, _settings_game.sharing.air_fee);
+
+	uint16 old_companies = this->allowed_companies;
+
+	/* allow all existing companies */
+	this->allowed_companies = 0;
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		SetBit(this->allowed_companies, c->index);
+	}
+
+	/* If any company permission is removed, invalidate all vehicle types */
+	if ((this->allowed_companies & old_companies) != old_companies) changed_vehtypes = 0xF;
+
+	return changed_vehtypes;
+}
+
+/**
+ * Helper function for transferring sharing fees
+ * @param v The vehicle involved
+ * @param owner The owner of the infrastructure
+ * @param cost Amount to transfer
+ */
+
+static void PaySharingFee(Vehicle *v, Owner owner, Money cost)
+{
+	v->profit_this_year -= cost;
+	SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_SHARED_RUN, cost));
+	SubtractMoneyFromCompanyFract(owner, CommandCost(EXPENSES_SHARED_INC, -cost));
+}
+
+void PayStationSharingFee(Vehicle *v, const Station *st)
+{
+	if (v->owner == st->owner || st->owner == OWNER_NONE || v->type == VEH_TRAIN) return;
+	Money cost = GetSharingFee(st->owner, v->type);
+	PaySharingFee(v, st->owner, (cost << 8) / DAY_TICKS);
+}
+
+void PayDailyTrackSharingFee(Vehicle *v)
+{
+	Owner owner = GetTileOwner(v->tile);
+	if (owner == v->owner || v->type != VEH_TRAIN) return;
+	Money cost = GetSharingFee(owner, VEH_TRAIN);
+	cost = (cost << 8) * v->u.rail.cached_total_length / 8;
+	cost = cost * 12 / DAYS_IN_YEAR; //cost is per month, but we pay daily.
+	PaySharingFee(v, owner, cost);
+}
+
+/**
+ * Change the company sharing settings
+ * @param tile unused
+ * @param flags operation to perform
+ * @param p1 var to change
+ * @param p2 value to change it to
+ * @param text unused
+ */
+CommandCost CmdChangeSharingSetting(TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
+{
+	if (!(_settings_game.sharing.enable_sharing && _settings_game.sharing.individual_allowed)) return CMD_ERROR;
+	VehicleType type = (VehicleType)(p1 % SHARING_VEHTYPES);
+	if (p1 < SHARING_FEE_RAIL) {
+		if (type == VEH_TRAIN) {
+			if (p2 > (SHARING_TRACK | SHARING_DEPOT | SHARING_STATION)) return CMD_ERROR;
+			/* don't allow any sharing without tracks enabled */
+			if (p2 > 0 && (p2 & SHARING_TRACK) == 0) return CMD_ERROR;
+		} else {
+			if (p2 != 0 && p2 != (SHARING_DEPOT | SHARING_STATION)) return CMD_ERROR;
+		}
+	} else if (p1 < SHARING_ALLOWED_COMPANIES) {
+		if (p2 > MAX_SHARING_FEE) return CMD_ERROR;
+	} else if (p1 == SHARING_ALLOWED_COMPANIES) {
+		/* a company mask should not have (1 << MAX_COMPANIES) or any higher bit set */
+		if (p2 >= (1 << MAX_COMPANIES)) return CMD_ERROR;
+		for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+			if (HasBit(p2, c) && !IsValidCompanyID(c)) return CMD_ERROR;
+		}
+		/* we prefer to keep ourselves allowed */
+		if (!HasBit(p2, _current_company)) return CMD_ERROR;
+	} else {
+		return CMD_ERROR;
+	}
+
+	if (flags & DC_EXEC) {
+		Company *c = GetCompany(_current_company);
+		if (p1 < SHARING_FEE_RAIL) {
+			c->sharing_future.SetSharingOption(type, p2);
+		} else if (p1 < SHARING_ALLOWED_COMPANIES) {
+			c->sharing_future.SetSharingFee(type, p2);
+		} else {
+			c->sharing_future.allowed_companies = p2;
+		}
+
+		/* Set the sharing delay, and copy the future settings to the current settings if needed */
+		if (c->sharing_future.Equals(&c->sharing_current)) {
+			c->sharing_delay = 0;
+		} else {
+			if (_settings_game.sharing.new_individual_delay == 0) {
+				/* Change is applied immediately, so warn users */
+				if (_current_company != _local_company) {
+					SetDParam(0, _current_company);
+					AddNewsItem(STR_SHARING_CHANGE_HAPPENED, NS_COMPANY_SHARING, 0, 0);
+				}
+
+				uint16 old_companies = c->sharing_current.allowed_companies;
+				c->sharing_current.Copy(&c->sharing_future);
+				if (p1 < SHARING_FEE_RAIL) {
+					HandleSharingChange(1 << p1);
+				} else if (p1 == SHARING_ALLOWED_COMPANIES) {
+					if ((p2 & old_companies) != old_companies) HandleSharingChange();
+				}
+			} else if (_current_company != _local_company) {
+				SetDParam(0, _current_company);
+				SetDParam(1, _current_company);
+				AddNewsItem(STR_SHARING_CHANGE_ANNOUNCED, NS_COMPANY_SHARING, 0, 0);
+			}
+			c->sharing_delay = _settings_game.sharing.new_individual_delay;
+		}
+
+		InvalidateWindow(WC_SHARING_OPTIONS, _current_company);
+	}
+	return CommandCost();
+}
+
+/**
+ * Sell a vehicle, no matter where it may be.
+ * Also make sure no artifacts are left, such as PBS paths
+ * @param v The vehicle to sell
+ */
+static void RemoveAndSellVehicle(Vehicle *v)
+{
+	if (v->type == VEH_TRAIN && !HASBITS(v->vehstatus, VS_CRASHED)) {
+		/* Clear path reservation. This will not clear any reservation that has become invalid, we will do that later */
+		FreeTrainTrackReservation(v);
+		for (const Vehicle *u = v; u != NULL; u = u->Next()) {
+			ClearPathReservation(u, u->tile, GetVehicleTrackdir(u));
+			if (IsTileType(u->tile, MP_TUNNELBRIDGE)) {
+				/* ClearPathReservation will not free the wormhole exit
+				 * if the train has just entered the wormhole. */
+				SetTunnelBridgeReservation(GetOtherTunnelBridgeEnd(u->tile), false);
+			}
+		}
+	}
+	SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_NEW_VEHICLES, -(v->value << 8)));
+	delete v;
+}
+
+
+/**
+ * Check the positions of all vehicles.
+ * If it is not in an allowed position,
+ * (e.g. it is in a depot when sharing of depots is disabled)
+ * then it is sold immediately.
+ * @param changed_vehtypes bitmask of vehicle types that were affected by a sharing setting change.
+ */
+static void CheckAllVehiclePositions(byte changed_vehtypes)
+{
+	uint num_sold_vehicles = 0;
+	Vehicle *v, *u;
+	FOR_ALL_VEHICLES(v) {
+		if (!(v->IsPrimaryVehicle() || (v->type == VEH_TRAIN && IsFreeWagon(v)))) continue;
+		if (!HasBit(changed_vehtypes, v->type)) continue;
+		switch (v->type) {
+			case VEH_TRAIN:
+				for (u = v; u != NULL; u = u->Next()) {
+					/* If any wagon is on a disallowed tile, sell the entire train */
+					if (!IsRailwayTileUsageAllowed(u->tile, v->owner)) {
+						if (v->owner == _local_company) num_sold_vehicles++;
+						RemoveAndSellVehicle(v);
+						break;
+					}
+				}
+				break;
+			case VEH_ROAD:
+				if ((IsRoadDepotTile(v->tile) && !IsDepotUsageAllowed(v->tile, v)) ||
+					(IsStandardRoadStopTile(v->tile) && !IsStationUsageAllowed(v->tile, v))) {
+						if (v->owner == _local_company) num_sold_vehicles++;
+						RemoveAndSellVehicle(v);
+				}
+				break;
+			case VEH_SHIP:
+				if (IsShipDepotTile(v->tile) && !IsDepotUsageAllowed(v->tile, v)) {
+					if (v->owner == _local_company) num_sold_vehicles++;
+					RemoveAndSellVehicle(v);
+				}
+				break;
+			case VEH_AIRCRAFT:
+				if (v->u.air.state == FLYING) break;
+				if (IsValidStationID(v->u.air.targetairport) &&
+					!IsStationUsageAllowed(GetStation(v->u.air.targetairport), v)) {
+						if (v->owner == _local_company) num_sold_vehicles++;
+						RemoveAndSellVehicle(v);
+				}
+				break;
+			default: break;
+		}
+	}
+	if (num_sold_vehicles > 0) {
+		SetDParam(0, num_sold_vehicles);
+		AddNewsItem(STR_SHARING_CHANGE_SOLD_VEHICLES, NS_COMPANY_SHARING, 0, 0);
+	}
+}
+
+/**
+ * Check whether an order has an allowed destination.
+ * I.e. it refers to a station/depot/waypoint the vehicle is allowed to visit.
+ * @param o The order to check
+ * @param v The vehicle this order belongs to.
+ * @return true if the order has an allowed destination.
+ */
+static bool OrderDestinationIsAllowed(const Order *o, const Vehicle *v)
+{
+	DestinationID dest = o->GetDestination();
+	switch (o->GetType()) {
+		case OT_GOTO_STATION:  return IsStationUsageAllowed(GetStation(dest), v);
+		case OT_GOTO_DEPOT:    return v->type == VEH_AIRCRAFT ? IsStationUsageAllowed(GetStation(dest), v) : IsDepotUsageAllowed(GetDepot(dest)->xy, v);
+		case OT_GOTO_WAYPOINT: return IsWaypointUsageAllowed(GetWaypoint(dest), v->owner);
+		default: return true;
+	}
+}
+
+/**
+ * Review the orders of all vehicles
+ * This makes sure they don't have any orders to destinations
+ * where they are not allowed to go.
+ * @param changed_vehtypes bitmask of vehicle types that were affected by a sharing setting change.
+ */
+static void ReviewAllVehicleOrders(byte changed_vehtypes)
+{
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (!(v->IsPrimaryVehicle() && HasBit(changed_vehtypes, v->type))) continue;
+
+		if (!OrderDestinationIsAllowed(&v->current_order, v)) {
+			v->current_order.MakeDummy();
+			InvalidateWindow(WC_VEHICLE_VIEW, v->index);
+		} else if (v->current_order.IsType(OT_LOADING)) {
+			if (!IsStationUsageAllowed(GetStation(v->last_station_visited), v)) {
+				v->LeaveStation();
+			}
+		}
+
+		if (v->FirstShared() != v) continue;
+
+		Order *o;
+		int id = -1;
+		FOR_VEHICLE_ORDERS(v, o) {
+			id++;
+			if (OrderDestinationIsAllowed(o, v)) continue;
+
+			o->MakeDummy();
+			for (const Vehicle *w = v->FirstShared(); w != NULL; w = w->NextShared()) {
+				/* In GUI, simulate by removing the order and adding it back */
+				InvalidateVehicleOrder(w, id | (INVALID_VEH_ORDER_ID << 8));
+				InvalidateVehicleOrder(w, (INVALID_VEH_ORDER_ID << 8) | id);
+			}
+		}
+	}
+}
+/**
+ * Helper proc for HasVehicleOnPos to determine whether there is a train on a certain track.
+ * @param v The vehicle that may be on this track
+ * @param track the track the train should be on.
+ * @return v if it is on this track, or null otherwise.
+ */
+static Vehicle *HasTrainOnTrackProc(Vehicle *v, void *track)
+{
+	if (v->type == VEH_TRAIN && (TrackBitsToTrack(v->u.rail.track) == *(Track *)track || v->u.rail.track == TRACK_BIT_WORMHOLE)) {
+		return v;
+	}
+	return NULL;
+}
+
+/**
+ * Check the reservations of all tiles.
+ * If these to not seem to belong to a train or the train is not allowed to use them, unreserve them.
+ */
+static void CheckAllReservations()
+{
+	Vehicle *v;
+	TrackBits bits;
+	Track track;
+	for (TileIndex tile = 0; tile < MapSize(); tile++) {
+		bits = GetReservedTrackbits(tile);
+		while (bits != TRACK_BIT_NONE) {
+			track = RemoveFirstTrack(&bits);
+			/* Don't bother continuing if there is a vehicle on this tile */
+			if (HasVehicleOnPos(tile, &track, &HasTrainOnTrackProc)) continue;
+
+			v = GetTrainForReservation(tile, track);
+			if (v == NULL) {
+				UnreserveRailTrack(tile, track);
+				/* make any PBS signal red */
+				Trackdir td = TrackToTrackdir(track);
+				if (HasPbsSignalOnTrackdir(tile, td)) SetSignalStateByTrackdir(tile, td, SIGNAL_STATE_RED);
+				if (HasPbsSignalOnTrackdir(tile, ReverseTrackdir(td))) SetSignalStateByTrackdir(tile, ReverseTrackdir(td), SIGNAL_STATE_RED);
+			}
+		}
+	}
+}
+
+/* Small struct to store a tile/track combination */
+struct SignalPosition {
+	TileIndex tile;
+	Track     track;
+	SignalPosition(TileIndex _tile, Track _track) : tile(_tile), track(_track) {};
+};
+
+/**
+ * Update all signals on the map.
+ * Since whe do not know which ones are affected by the sharing change, we invalidate them all.
+ * Updating signals can only be done on a per-company basis.
+ * Therefore, we cache all signals into lists, one per company
+ * Then we update all signals in each list.
+ */
+static void UpdateBlockSignals()
+{
+	SmallVector<SignalPosition, 256> signal_lists[MAX_COMPANIES];
+
+	for (TileIndex tile = 0; tile < MapSize(); tile++) {
+		if (IsTileType(tile, MP_RAILWAY) && HasSignals(tile)) {
+			TrackBits bits = GetTrackBits(tile);
+			do {
+				Track track = RemoveFirstTrack(&bits);
+				if (HasSignalOnTrack(tile, track)) {
+					*signal_lists[GetTileOwner(tile)].Append() = SignalPosition(tile, track);
+				}
+			} while (bits != TRACK_BIT_NONE);
+		}
+	}
+	for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+		for (uint i = 0; i < signal_lists[c].Length(); i++) {
+			AddTrackToSignalBuffer(signal_lists[c][i].tile, signal_lists[c][i].track, c);
+		}
+		UpdateSignalsInBuffer();
+		signal_lists[c].Reset();
+	}
+}
+
+void HandleSharingChange(byte changed_vehtypes)
+{
+	if (changed_vehtypes == 0) return;
+	CheckAllVehiclePositions(changed_vehtypes);
+	ReviewAllVehicleOrders(changed_vehtypes);
+	if (HasBit(changed_vehtypes, VEH_TRAIN)) {
+		CheckAllReservations();
+		UpdateBlockSignals();
+	}
+}
diff -r ee55d0546576 src/infrastructure.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/infrastructure.h	Sat Apr 25 19:58:24 2009 +0200
@@ -0,0 +1,125 @@
+/** @file infrastructure.h Define struct and enums for (shared) infrastructure */
+
+#ifndef INFRASTRUCTURE_H
+#define INFRASTRUCTURE_H
+
+#include "stdafx.h"
+#include "core/bitmath_func.hpp"
+#include "vehicle_type.h"
+#include "company_type.h"
+
+/** flags for enabling / disabling various types of infrastructure */
+enum SharingOption {
+	SHARING_STATION = 1 << 0, ///< Stations are shared
+	SHARING_DEPOT   = 1 << 1, ///< Depots are shared
+	SHARING_TRACK   = 1 << 2, ///< Tracks are shared. (Trains only)
+};
+
+/** which part of the sharing settings do we want to modify? */
+enum ModifySharingFlag {
+	SHARING_SETTING_RAIL,      ///< train setting
+	SHARING_SETTING_ROAD,      ///< road vehicle setting
+	SHARING_SETTING_WATER,     ///< ship setting
+	SHARING_SETTING_AIR,       ///< air setting
+
+	SHARING_FEE_RAIL,          ///< train fee
+	SHARING_FEE_ROAD,          ///< road stopping fee
+	SHARING_FEE_WATER,         ///< ship docking fee
+	SHARING_FEE_AIR,           ///< air landing fee
+
+	SHARING_ALLOWED_COMPANIES, ///< allowed companies bitmask
+	SHARING_END,
+};
+
+/** maximum fee for any of the sharing fees */
+static const uint MAX_SHARING_FEE = 50000;
+
+/** number of relevant vehicle types */
+static const byte SHARING_VEHTYPES = 4;
+
+struct CompanySharingSettingsEntry {
+	byte option[SHARING_VEHTYPES]; ///< sharing options for rail/road/water/air
+	uint16 fee[SHARING_VEHTYPES];  ///< fees for rail/road/water/air
+	CompanyMask allowed_companies; ///< which companies do we allow to use our infrastructure?
+
+	/** Constructor */
+	CompanySharingSettingsEntry() {}
+
+	/**
+	 * Compare two sets of sharing settings with eachother.
+	 * @param o The sharing settings entry to compare with.
+	 * @return True if all settings are equal, false otherwise.
+	 */
+	bool Equals(CompanySharingSettingsEntry *o);
+
+	/**
+	 * Copy the data of a specified sharing settings entry to this one.
+	 * @param o The sharing settings entry to use as source.
+	 * @return a bitmask of vehicle types whose permissions were reduced.
+	 */
+	byte Copy(CompanySharingSettingsEntry *o);
+
+	/**
+	 * Get the sharing option for a vehicle type.
+	 * @param type The vehicle type.
+	 * @return The sharing option for the specified vehicle type
+	 */
+	inline byte GetSharingOption(VehicleType type) const
+	{
+		assert(type < SHARING_VEHTYPES);
+		return this->option[type];
+	}
+
+	/**
+	 * Get the sharing fee for a specified vehicle type.
+	 * @param type The vehicle type.
+	 * @return The sharing fee for the given vehicle type.
+	 */
+	inline uint16 GetSharingFee(VehicleType type) const
+	{
+		assert(type < SHARING_VEHTYPES);
+		return this->fee[type];
+	}
+
+	/**
+	 * Set the sharing fee for a vehicle type.
+	 * @param type The vehicle type.
+	 * @value The sharing option to set for the given vehicle type.
+	 */
+	inline void SetSharingOption(VehicleType type, byte value)
+	{
+		assert(type < SHARING_VEHTYPES);
+		this->option[type] = value;
+	}
+
+	/**
+	 * Set the sharing fee for a specified vehicle type.
+	 * @param type The vehicle type.
+	 * @param value The new sharing fee.
+	 */
+	inline void SetSharingFee(VehicleType type, uint16 value)
+	{
+		assert(type < SHARING_VEHTYPES);
+		this->fee[type] = value;
+	}
+
+	/**
+	 * Check whether a company is allowed to use the infrastructure.
+	 * i.e. it's corresponding bit in allowed_companies is set.
+	 * @param c The company to check.
+	 * @return true if the given company is allowed to use the infrastructure
+	 */
+	inline bool IsCompanyAllowed(CompanyID c)
+	{
+		return HasBit(this->allowed_companies, c);
+	}
+
+	/**
+	 * Fill this struct with the values from _settings_game.
+	 * This also enables all companies in the allowed_companies mask.
+	 * @return a bitmask of vehicle types whose permissions were reduced.
+	 */
+	byte CopyFromGameSettings();
+};
+
+#endif /* INFRASTRUCTURE_H */
diff -r ee55d0546576 src/infrastructure_func.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/infrastructure_func.h	Sat Apr 25 19:58:24 2009 +0200
@@ -0,0 +1,221 @@
+/** @file infrastructure_func.h Functions for infrastructure sharing */
+
+#ifndef INFRASTRUCTURE_FUNC_H
+#define INFRASTRUCTURE_FUNC_H
+
+#include "station_map.h"
+#include "functions.h"
+#include "company_base.h"
+#include "waypoint.h"
+#include "vehicle_base.h"
+#include "company_func.h"
+
+/**
+ * Pay the fee for spending a single tick inside a station.
+ * @param v The vehicle that is using the station.
+ * @param st The station that it uses.
+ */
+void PayStationSharingFee(Vehicle *v, const Station *st);
+
+/**
+ * Pay the daily fee for trains on foreign tracks.
+ * @param v The vehicle to pay the fee for.
+ */
+void PayDailyTrackSharingFee(Vehicle *v);
+
+/**
+ * Handle a change of sharing settings.
+ * This involves checking all orders,
+ * making sure all vehicles are not on disallowed territory,
+ * checking all PBS paths
+ * and updating signals.
+ * @param changed_vehtypes Bitmask of vehicle types whose sharing settings were changed. Default is 0xF (all types)
+ */
+void HandleSharingChange(byte changed_vehtypes = 0xF);
+
+/**
+ * Get the sharing setting for a given infrastructure owner, vehicle owner and vehicle type.
+ * This also checks whether the vehicle owner is allowed according to the allowed_companies bitmask.
+ * @see SharingOption
+ * @param owner The owner of the infrastructure.
+ * @param veh_owner Owner of the vehicle in question.
+ * @param type Type of vehicle we are talking about.
+ * @return The sharing option(s) that apply here.
+ */
+static inline byte GetSharingSetting(Owner owner, Owner veh_owner, VehicleType type) {
+	Company *c = GetCompany(owner);
+	return c->sharing_current.IsCompanyAllowed(veh_owner) ? c->sharing_current.GetSharingOption(type) : 0;
+}
+
+/**
+ * Get the sharing fee the infrastructure owner asks for using the infrastructure for a vehicle type.
+ * @param owner The owner of the infrastructure.
+ * @param type The vehicle type.
+ * @return The sharing fee that applies here.
+ */
+static inline uint16 GetSharingFee(Owner owner, VehicleType type) {
+	return GetCompany(owner)->sharing_current.GetSharingFee(type);
+}
+
+/**
+ * Check whether the given owner is allowed to use rails on this tile.
+ * It should either own the tile, or the tile owner should have sharing of tracks enabled (for this company).
+ * @param t The (railway) tile.
+ * @param owner The owner of the vehicle that wants to use this tile.
+ * @return true if the given owner is allowed to use this railway tile.
+ */
+static inline bool IsRailUsageAllowed(TileIndex t, Owner owner) {
+	return IsTileOwner(t, owner) || GetSharingSetting(GetTileOwner(t), owner, VEH_TRAIN) & SHARING_TRACK;
+}
+
+/**
+ * Check whether the given owner is allowed to use this waypoint for his trains.
+ * It should either own the waypoint, or the waypoint owner should have sharing of tracks enabled (for this company).
+ * @param wp The waypoint to test.
+ * @param owner The owner of the vehicle that wants to use this waypoint.
+ * @return true if the given owner is allowed to use this waypoint.
+ */
+static inline bool IsWaypointUsageAllowed(const Waypoint *wp, Owner owner) {
+	return wp->owner == owner || GetSharingSetting(wp->owner, owner, VEH_TRAIN) & SHARING_TRACK;
+}
+
+/**
+ * Check whether the given owner is allowed to use this depot.
+ * It should either own the depot, or the depot owner should have sharing of depots enabled (for this company).
+ * For non-trains, depot sharing is enabled automagically when sharing of stations is enabled.
+ * @param t The depot tile.
+ * @param owner The owner of the vehicle that wants to use this depot.
+ * @param type The vehicle type we are talking about.
+ * @return true if the given owner is allowed to use this depot.
+ */
+static inline bool IsDepotUsageAllowed(TileIndex t, Owner owner, VehicleType type) {
+	return IsTileOwner(t, owner) || GetSharingSetting(GetTileOwner(t), owner, type) & SHARING_DEPOT;
+}
+
+/**
+ * Check whether the given vehicle is allowed to use this depot.
+ * The vehicle owner should either own the depot, or the depot owner should have sharing of depots enabled (for this company).
+ * For non-trains, depot sharing is enabled automagically when sharing of stations is enabled.
+ * @param t The depot tile.
+ * @param v The vehicle that intends to use this depot.
+ * @return true if the given vehicle is allowed to use this depot.
+ */
+static inline bool IsDepotUsageAllowed(TileIndex t, const Vehicle *v) {
+	return IsDepotUsageAllowed(t, v->owner, v->type);
+}
+
+/**
+ * Check whether a given vehicle owner is allowed to use a station.
+ * He should either own the station, the station should have a non-company owner (oil rigs/buoys),
+ * or the station owner should have sharing of stations enabled (for this company).
+ * @param st A tile of the station.
+ * @param owner The vehicle owner
+ * @param type The vehicle type to test.
+ * @return true if the given owner is allowed to use this station.
+ */
+static inline bool IsStationUsageAllowed(TileIndex t, Owner owner, VehicleType type) {
+	Owner tile_owner = GetTileOwner(t);
+	return tile_owner == owner || tile_owner == OWNER_NONE || tile_owner == OWNER_WATER || GetSharingSetting(tile_owner, owner, type) & SHARING_STATION;
+}
+
+/**
+ * Check whether the given vehicle is allowed to use this station.
+ * The vehicle owner should either own the station, the station should have a non-company owner (oil rigs/buoys),
+ * or the station owner should have sharing of stations enabled (for this company).
+ * @param st The station.
+ * @param v The vehicle that intends to use this station.
+ * @return true if the given vehicle is allowed to use this station.
+ */
+static inline bool IsStationUsageAllowed(const Station *st, const Vehicle *v) {
+	return st->owner == v->owner || st->owner == OWNER_NONE || st->owner == OWNER_WATER || GetSharingSetting(st->owner, v->owner, v->type) & SHARING_STATION;
+}
+
+/**
+ * Check whether the given vehicle is allowed to use a station.
+ * The vehicle owner should either own the station, the station should have no owner (oil rigs),
+ * or the depot owner should have sharing of stations enabled (for this company).
+ * @param st A tile of the station.
+ * @param v The vehicle that intends to use this station.
+ * @return true if the given vehicle is allowed to use this station.
+ */
+static inline bool IsStationUsageAllowed(TileIndex t, const Vehicle *v) {
+	return IsStationUsageAllowed(t, v->owner, v->type);
+}
+
+/**
+ * Check whether the current company can control this vehicle.
+ * The vehicle owner can always control a vehicle.
+ * Trains on foreign tracks can also be controlled by the track owner.
+ * Controlling a train means permission to start, stop or reverse it or to make it ignore signals.
+ * @param v The vehicle which may or may not be controlled.
+ * @return true if the current company is allowed to control this vehicle.
+ */
+static inline bool IsVehicleControlAllowed(const Vehicle *v) {
+	return CheckOwnership(v->owner) || (v->type == VEH_TRAIN && CheckTileOwnership(v->tile));
+}
+
+/**
+ * Check whether a given company can control this vehicle.
+ * The vehicle owner can always control a vehicle.
+ * Trains on foreign tracks can also be controlled by the track owner.
+ * Controlling a train means permission to start, stop or reverse it or to make it ignore signals.
+ * @param v The vehicle which may or may not be controlled.
+ * @param c The company which may or may not control this vehicle
+ * @return true if the given company is allowed to control this vehicle.
+ */
+static inline bool IsVehicleControlAllowed(const Vehicle *v, CompanyByte c) {
+	return v->owner == c || (v->type == VEH_TRAIN && IsTileOwner(v->tile, c));
+}
+
+/**
+ * Check whether usage of a railway tile is allowed.
+ * The tile to check can be any tile with rail on it,
+ * such as normal rail, depots, stations or bridges.
+ * This is actually assumed to be the case, but not checked.
+ * @param tile The tile to check.
+ * @param owner Owner of the train that wants to use that tile.
+ * @return true if the vehicle can use the tile.
+ */
+static inline bool IsRailwayTileUsageAllowed(TileIndex tile, Owner owner)
+{
+	if (IsTileType(tile, MP_STATION)) return IsStationUsageAllowed(tile, owner, VEH_TRAIN);
+	if (IsRailDepotTile(tile)) return IsDepotUsageAllowed(tile, owner, VEH_TRAIN);
+	return IsRailUsageAllowed(tile, owner);
+}
+
+/**
+ * Are the tracks of two owners part of the same signal block?
+ * This is the case if the owners are equal, or if infrastructure sharing is enabled
+ * @param o1 First company.
+ * @param o2 Second company.
+ * @return true if the tracks of the given owners are part of the same signal block
+ */
+static inline bool AreSignalBlocksJoined(Owner o1, Owner o2)
+{
+	return (o1 == o2) || _settings_game.sharing.enable_sharing;
+}
+
+/**
+ * Is a company allowed to do depot operations? (buying/selling/reordering/autoreplace)
+ * This is allowed if the company is allowed to use the depot.
+ * For the sake of flexibility, a separate function (this one) is used.
+ * @param tile The tile of the depot.
+ * @param owner The company what wants to do depot operations.
+ * @param type The type of vehicle
+ * @return True it the depot operations are allowed
+ */
+static inline bool AreDepotOperationsAllowed(TileIndex tile, Owner owner, VehicleType type)
+{
+	return IsDepotUsageAllowed(tile, owner, type);
+}
+
+/**
+ * Should the smallmap window show whether rail tracks are accessible?
+ * @return true if the local company is valid and sharing is enabled
+ */
+static inline bool ShowSharingOnMap()
+{
+	return _settings_game.sharing.enable_sharing && IsValidCompanyID(_local_company);
+}
+
+#endif /* INFRASTRUCTURE_FUNC_H */
diff -r ee55d0546576 src/news_gui.cpp
--- a/src/news_gui.cpp	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/news_gui.cpp	Sat Apr 25 19:58:24 2009 +0200
@@ -114,6 +114,7 @@
 	{ NT_COMPANY_INFO,     NM_NORMAL,   NF_NONE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_MERGER
 	{ NT_COMPANY_INFO,     NM_NORMAL,   NF_NONE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_BANKRUPT
 	{ NT_COMPANY_INFO,     NM_NORMAL,   NF_TILE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_NEW
+	{ NT_COMPANY_INFO,     NM_NORMAL,   NF_NONE,                NULL                    }, ///< NS_COMPANY_SHARING
 	{ NT_INDUSTRY_OPEN,    NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_INDUSTRY_OPEN
 	{ NT_INDUSTRY_CLOSE,   NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_INDUSTRY_CLOSE
 	{ NT_ECONOMY,          NM_NORMAL,   NF_NONE,                NULL                    }, ///< NS_ECONOMY
diff -r ee55d0546576 src/news_type.h
--- a/src/news_type.h	Sat Apr 25 12:00:54 2009 +0000
+++ b/src/news_type.h	Sat Apr 25 19:58:24 2009 +0200
@@ -43,6 +43,7 @@
 	NS_COMPANY_MERGER,   ///< NT_COMPANY_INFO (merger)
 	NS_COMPANY_BANKRUPT, ///< NT_COMPANY_INFO (bankrupt)
 	NS_COMPANY_NEW,      ///< NT_COMPANY_INFO (new company)
+	NS_COMPANY_SHARING,  ///< NT_COMPANY_INFO (change of sharing settings)
 	NS_INDUSTRY_OPEN,    ///< NT_INDUSTRY_OPEN
 	NS_INDUSTRY_CLOSE,   ///< NT_INDUSTRY_CLOSE
 	NS_ECONOMY,          ///< NT_ECONOMY
